"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Attachments = exports._Attachments = exports.Attachment = exports._Attachment = void 0;
var tslib_1 = require("tslib");
var odata_1 = require("@pnp/odata-commonjs");
var graphqueryable_js_1 = require("../graphqueryable.js");
var operations_js_1 = require("../operations.js");
var decorators_js_1 = require("../decorators.js");
var type_js_1 = require("../utils/type.js");
/**
 * Attachment
 */
var _Attachment = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_Attachment, _super);
    function _Attachment() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return _Attachment;
}(graphqueryable_js_1._GraphQueryableInstance));
exports._Attachment = _Attachment;
exports.Attachment = (0, graphqueryable_js_1.graphInvokableFactory)(_Attachment);
/**
 * Attachments
 */
var _Attachments = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_Attachments, _super);
    function _Attachments() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Add attachment to this collection
     *
     * @param name Name given to the attachment file
     * @param bytes File content
     */
    _Attachments.prototype.addFile = function (name, bytes) {
        return (0, operations_js_1.graphPost)(this, (0, odata_1.body)((0, type_js_1.type)("#microsoft.graph.fileAttachment", {
            contentBytes: bytes,
            name: name,
        })));
    };
    _Attachments = (0, tslib_1.__decorate)([
        (0, decorators_js_1.defaultPath)("attachments"),
        (0, decorators_js_1.getById)(exports.Attachment)
    ], _Attachments);
    return _Attachments;
}(graphqueryable_js_1._GraphQueryableCollection));
exports._Attachments = _Attachments;
exports.Attachments = (0, graphqueryable_js_1.graphInvokableFactory)(_Attachments);
//# sourceMappingURL=types.js.map