"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Communications = exports._Communications = exports.Presence = exports._Presence = void 0;
var tslib_1 = require("tslib");
var odata_1 = require("@pnp/odata-commonjs");
var graphqueryable_js_1 = require("../graphqueryable.js");
var decorators_js_1 = require("../decorators.js");
var operations_js_1 = require("../operations.js");
/**
 * Presence
 */
var _Presence = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_Presence, _super);
    function _Presence() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    _Presence = (0, tslib_1.__decorate)([
        (0, decorators_js_1.defaultPath)("presence")
    ], _Presence);
    return _Presence;
}(graphqueryable_js_1._GraphQueryableInstance));
exports._Presence = _Presence;
exports.Presence = (0, graphqueryable_js_1.graphInvokableFactory)(_Presence);
var _Communications = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_Communications, _super);
    function _Communications() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Retrieve presence information for a group of users.
     *
     * @param ids An array of user id's to retrieve presence for.
     */
    _Communications.prototype.getPresencesByUserId = function (ids) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var postBody;
            return (0, tslib_1.__generator)(this, function (_a) {
                postBody = { ids: ids };
                return [2 /*return*/, (0, operations_js_1.graphPost)(this.clone(exports.Communications, "getPresencesByUserId"), (0, odata_1.body)(postBody))];
            });
        });
    };
    _Communications = (0, tslib_1.__decorate)([
        (0, decorators_js_1.defaultPath)("communications")
    ], _Communications);
    return _Communications;
}(graphqueryable_js_1._GraphQueryableCollection));
exports._Communications = _Communications;
exports.Communications = (0, graphqueryable_js_1.graphInvokableFactory)(_Communications);
//# sourceMappingURL=types.js.map