"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Members = exports._Members = exports.Member = exports._Member = void 0;
var tslib_1 = require("tslib");
var odata_1 = require("@pnp/odata-commonjs");
var graphqueryable_js_1 = require("../graphqueryable.js");
var decorators_js_1 = require("../decorators.js");
var operations_js_1 = require("../operations.js");
/**
 * Member
 */
var _Member = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_Member, _super);
    function _Member() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Removes this Member
     */
    _Member.prototype.remove = function () {
        return (0, operations_js_1.graphDelete)(this.clone(exports.Member, "$ref"));
    };
    return _Member;
}(graphqueryable_js_1._GraphQueryableInstance));
exports._Member = _Member;
exports.Member = (0, graphqueryable_js_1.graphInvokableFactory)(_Member);
/**
 * Members
 */
var _Members = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_Members, _super);
    function _Members() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Use this API to add a member to an Office 365 group, a security group or a mail-enabled security group through
     * the members navigation property. You can add users or other groups.
     * Important: You can add only users to Office 365 groups.
     *
     * @param id Full @odata.id of the directoryObject, user, or group object you want to add (ex: `https://graph.microsoft.com/v1.0/directoryObjects/${id}`)
     */
    _Members.prototype.add = function (id) {
        return (0, operations_js_1.graphPost)(this.clone(exports.Members, "$ref"), (0, odata_1.body)({ "@odata.id": id }));
    };
    _Members = (0, tslib_1.__decorate)([
        (0, decorators_js_1.defaultPath)("members"),
        (0, decorators_js_1.getById)(exports.Member)
    ], _Members);
    return _Members;
}(graphqueryable_js_1._GraphQueryableCollection));
exports._Members = _Members;
exports.Members = (0, graphqueryable_js_1.graphInvokableFactory)(_Members);
//# sourceMappingURL=types.js.map