"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MasterCategories = exports._MasterCategories = exports.OutlookCategory = exports._OutlookCategory = exports.Outlook = exports._Outlook = void 0;
var tslib_1 = require("tslib");
var graphqueryable_1 = require("@pnp/graph-commonjs/graphqueryable");
var decorators_1 = require("@pnp/graph-commonjs/decorators");
var graph_1 = require("@pnp/graph-commonjs");
var odata_1 = require("@pnp/odata-commonjs");
/**
 * Outlook
 */
var _Outlook = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_Outlook, _super);
    function _Outlook() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(_Outlook.prototype, "masterCategories", {
        get: function () {
            return (0, exports.MasterCategories)(this);
        },
        enumerable: false,
        configurable: true
    });
    return _Outlook;
}(graphqueryable_1._GraphQueryableInstance));
exports._Outlook = _Outlook;
exports.Outlook = (0, graphqueryable_1.graphInvokableFactory)(_Outlook);
/**
 * Describes an Outlook Category instance
 */
var _OutlookCategory = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_OutlookCategory, _super);
    function _OutlookCategory() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    _OutlookCategory = (0, tslib_1.__decorate)([
        (0, decorators_1.deleteable)(),
        (0, decorators_1.updateable)()
    ], _OutlookCategory);
    return _OutlookCategory;
}(graphqueryable_1._GraphQueryableInstance));
exports._OutlookCategory = _OutlookCategory;
exports.OutlookCategory = (0, graphqueryable_1.graphInvokableFactory)(_OutlookCategory);
/**
 * Categories
 */
var _MasterCategories = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_MasterCategories, _super);
    function _MasterCategories() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Adds a new event to the collection
     *
     * @param properties The set of properties used to create the event
     */
    _MasterCategories.prototype.add = function (properties) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var data;
            return (0, tslib_1.__generator)(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, (0, graph_1.graphPost)(this, (0, odata_1.body)(properties))];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, {
                                data: data,
                            }];
                }
            });
        });
    };
    _MasterCategories = (0, tslib_1.__decorate)([
        (0, decorators_1.defaultPath)("masterCategories"),
        (0, decorators_1.getById)(exports.OutlookCategory)
    ], _MasterCategories);
    return _MasterCategories;
}(graphqueryable_1._GraphQueryableCollection));
exports._MasterCategories = _MasterCategories;
exports.MasterCategories = (0, graphqueryable_1.graphInvokableFactory)(_MasterCategories);
//# sourceMappingURL=types.js.map