"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Photo = exports._Photo = void 0;
var tslib_1 = require("tslib");
var graphqueryable_js_1 = require("../graphqueryable.js");
var odata_1 = require("@pnp/odata-commonjs");
var decorators_js_1 = require("../decorators.js");
var operations_js_1 = require("../operations.js");
var _Photo = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_Photo, _super);
    function _Photo() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Gets the image bytes as a blob (browser)
     */
    _Photo.prototype.getBlob = function () {
        return this.clone(exports.Photo, "$value", false).usingParser(new odata_1.BlobParser())();
    };
    /**
     * Gets the image file bytes as a Buffer (node.js)
     */
    _Photo.prototype.getBuffer = function () {
        return this.clone(exports.Photo, "$value", false).usingParser(new odata_1.BufferParser())();
    };
    /**
     * Sets the file bytes
     *
     * @param content Image file contents, max 4 MB
     */
    _Photo.prototype.setContent = function (content) {
        return (0, operations_js_1.graphPatch)(this.clone(exports.Photo, "$value", false), { body: content });
    };
    _Photo = (0, tslib_1.__decorate)([
        (0, decorators_js_1.defaultPath)("photo")
    ], _Photo);
    return _Photo;
}(graphqueryable_js_1._GraphQueryableInstance));
exports._Photo = _Photo;
exports.Photo = (0, graphqueryable_js_1.graphInvokableFactory)(_Photo);
//# sourceMappingURL=types.js.map