"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.People = exports._People = exports.Users = exports._Users = exports.User = exports._User = void 0;
var tslib_1 = require("tslib");
var graphqueryable_js_1 = require("../graphqueryable.js");
var types_js_1 = require("../directory-objects/types.js");
var decorators_js_1 = require("../decorators.js");
var _User = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_User, _super);
    function _User() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(_User.prototype, "memberOf", {
        /**
        * The groups and directory roles associated with the user
        */
        get: function () {
            return (0, types_js_1.DirectoryObjects)(this, "memberOf");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(_User.prototype, "people", {
        /**
         * Retrieve a collection of person objects ordered by their relevance to the user
         */
        get: function () {
            return (0, exports.People)(this);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(_User.prototype, "directReports", {
        /**
        * People that have direct reports to the user
        */
        get: function () {
            return (0, exports.People)(this, "directReports");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(_User.prototype, "manager", {
        /**
        * The manager associated with this user
        */
        get: function () {
            return (0, exports.User)(this, "manager");
        },
        enumerable: false,
        configurable: true
    });
    _User = (0, tslib_1.__decorate)([
        (0, decorators_js_1.updateable)(),
        (0, decorators_js_1.deleteable)()
    ], _User);
    return _User;
}(types_js_1._DirectoryObject));
exports._User = _User;
exports.User = (0, graphqueryable_js_1.graphInvokableFactory)(_User);
var _Users = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_Users, _super);
    function _Users() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    _Users = (0, tslib_1.__decorate)([
        (0, decorators_js_1.defaultPath)("users"),
        (0, decorators_js_1.getById)(exports.User)
    ], _Users);
    return _Users;
}(graphqueryable_js_1._GraphQueryableSearchableCollection));
exports._Users = _Users;
exports.Users = (0, graphqueryable_js_1.graphInvokableFactory)(_Users);
var _People = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(_People, _super);
    function _People() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    _People = (0, tslib_1.__decorate)([
        (0, decorators_js_1.defaultPath)("people")
    ], _People);
    return _People;
}(graphqueryable_js_1._GraphQueryableSearchableCollection));
exports._People = _People;
exports.People = (0, graphqueryable_js_1.graphInvokableFactory)(_People);
//# sourceMappingURL=types.js.map